# HG changeset patch
# Node ID 7349d70e5358
# Parent  63de4915950b
diff --git a/libpurple/blistnode.h b/libpurple/blistnode.h
--- a/libpurple/blistnode.h
+++ b/libpurple/blistnode.h
@@ -29,6 +29,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_BLIST_NODE             (purple_blist_node_get_type())
 #define PURPLE_BLIST_NODE(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), PURPLE_TYPE_BLIST_NODE, PurpleBlistNode))
 #define PURPLE_BLIST_NODE_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), PURPLE_TYPE_BLIST_NODE, PurpleBlistNodeClass))
@@ -250,6 +252,7 @@ void purple_blist_node_remove_setting(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_node_set_transient(PurpleBlistNode *node, gboolean transient);
 
 /**
@@ -262,6 +265,7 @@ void purple_blist_node_set_transient(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_blist_node_is_transient(PurpleBlistNode *node);
 
 /**
diff --git a/libpurple/buddy.h b/libpurple/buddy.h
--- a/libpurple/buddy.h
+++ b/libpurple/buddy.h
@@ -44,6 +44,7 @@ typedef struct _PurpleBuddyClass PurpleB
 #include "media.h"
 #include "purpleaccount.h"
 #include "purplepresence.h"
+#include "purpleversion.h"
 #include "status.h"
 
 /**
@@ -130,6 +131,7 @@ PurpleBuddy *purple_buddy_new(PurpleAcco
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_buddy_get_id(PurpleBuddy *buddy);
 
 /**
diff --git a/libpurple/buddyicon.h b/libpurple/buddyicon.h
--- a/libpurple/buddyicon.h
+++ b/libpurple/buddyicon.h
@@ -50,6 +50,7 @@ typedef struct _PurpleBuddyIconSpec Purp
 #include "image.h"
 #include "protocols.h"
 #include "purpleaccount.h"
+#include "purpleversion.h"
 #include "util.h"
 
 /**
@@ -177,6 +178,7 @@ purple_buddy_icon_set_data(PurpleBuddyIc
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_buddy_icon_save_to_filename(PurpleBuddyIcon *icon, const gchar *filename, GError **error);
 
 /**
@@ -233,6 +235,7 @@ gconstpointer purple_buddy_icon_get_data
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GInputStream *purple_buddy_icon_get_stream(PurpleBuddyIcon *icon);
 
 /**
@@ -520,6 +523,7 @@ PurpleBuddyIconSpec *purple_buddy_icon_s
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_buddy_icon_spec_free(PurpleBuddyIconSpec *spec);
 
 /**
diff --git a/libpurple/buddylist.h b/libpurple/buddylist.h
--- a/libpurple/buddylist.h
+++ b/libpurple/buddylist.h
@@ -30,6 +30,7 @@
 
 #include "buddy.h"
 #include "purpleaccount.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_BUDDY_LIST (purple_buddy_list_get_type())
 typedef struct _PurpleBuddyList PurpleBuddyList;
@@ -67,6 +68,7 @@ const gchar *
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleBlistWalkFunc)(PurpleBlistNode *node, gpointer data);
 
 /**************************************************************************/
@@ -180,6 +182,7 @@ G_DECLARE_DERIVABLE_TYPE(PurpleBuddyList
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBuddyList *purple_blist_get_default(void);
 
 /**
@@ -191,6 +194,7 @@ PurpleBuddyList *purple_blist_get_defaul
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBlistNode *purple_blist_get_default_root(void);
 
 /**
@@ -447,6 +451,7 @@ void purple_blist_remove_account(PurpleA
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_walk(PurpleBlistWalkFunc group_func, PurpleBlistWalkFunc chat_func, PurpleBlistWalkFunc meta_contact_func, PurpleBlistWalkFunc contact_func, gpointer data);
 
 /**
@@ -458,6 +463,7 @@ void purple_blist_walk(PurpleBlistWalkFu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_blist_get_default_group_name(void);
 
 /****************************************************************************************/
@@ -521,6 +527,7 @@ void purple_blist_request_add_group(void
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_new_node(PurpleBuddyList *list, PurpleBlistNode *node);
 
 /**
@@ -532,6 +539,7 @@ void purple_blist_new_node(PurpleBuddyLi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_update_node(PurpleBuddyList *list, PurpleBlistNode *node);
 
 /**
@@ -546,6 +554,7 @@ void purple_blist_update_node(PurpleBudd
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_save_node(PurpleBuddyList *list, PurpleBlistNode *node);
 
 /**
@@ -561,6 +570,7 @@ void purple_blist_save_node(PurpleBuddyL
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_save_account(PurpleBuddyList *list, PurpleAccount *account);
 
 /**************************************************************************/
@@ -578,6 +588,7 @@ void purple_blist_save_account(PurpleBud
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_set_ui(GType type);
 
 /**
diff --git a/libpurple/connection.h b/libpurple/connection.h
--- a/libpurple/connection.h
+++ b/libpurple/connection.h
@@ -29,6 +29,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CONNECTION  purple_connection_get_type()
@@ -99,7 +101,9 @@ typedef enum {
  *
  * Since: 3.0.0
  */
-#define PURPLE_CONNECTION_ERROR (g_quark_from_static_string("purple-connection-error"))
+#define PURPLE_CONNECTION_ERROR \
+	g_quark_from_static_string("purple-connection-error") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 #include "purpleaccount.h"
 #include "purpleconnectionerrorinfo.h"
@@ -195,6 +199,7 @@ void
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_connection_connect(PurpleConnection *connection, GError **error);
 
 /**
@@ -214,6 +219,7 @@ gboolean purple_connection_connect(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_connection_disconnect(PurpleConnection *connection, GError **error);
 
 /**
@@ -238,6 +244,7 @@ void purple_connection_set_state(PurpleC
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_connection_set_flags(PurpleConnection *gc, PurpleConnectionFlags flags);
 
 /**
@@ -278,6 +285,7 @@ PurpleConnectionState purple_connection_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConnectionFlags purple_connection_get_flags(PurpleConnection *gc);
 
 /**
@@ -300,6 +308,7 @@ PurpleConnectionFlags purple_connection_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_connection_get_id(PurpleConnection *connection);
 
 /**
@@ -347,6 +356,7 @@ const char *purple_connection_get_passwo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_connection_set_password(PurpleConnection *connection, const char *password);
 
 /**
@@ -360,6 +370,7 @@ void purple_connection_set_password(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GSList *purple_connection_get_active_chats(PurpleConnection *gc);
 
 /**
@@ -408,6 +419,7 @@ purple_connection_error(PurpleConnection
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConnectionErrorInfo *
 purple_connection_get_error_info(PurpleConnection *gc);
 
@@ -427,6 +439,7 @@ purple_connection_get_error_info(PurpleC
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_connection_g_error(PurpleConnection *pc, const GError *error);
 
 /**
@@ -442,6 +455,7 @@ void purple_connection_g_error(PurpleCon
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_connection_take_error(PurpleConnection *pc, GError *error);
 
 /**
@@ -478,6 +492,7 @@ purple_connection_error_is_fatal (Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_connection_update_last_received(PurpleConnection *gc);
 
 /**************************************************************************/
diff --git a/libpurple/core.h b/libpurple/core.h
--- a/libpurple/core.h
+++ b/libpurple/core.h
@@ -30,6 +30,7 @@
 #include <glib-object.h>
 
 #include "purpleui.h"
+#include "purpleversion.h"
 
 typedef struct PurpleCore PurpleCore;
 
@@ -87,6 +88,7 @@ PurpleCore *purple_get_core(void);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gpointer purple_core_get_settings_backend(void);
 
 /**
diff --git a/libpurple/countingnode.h b/libpurple/countingnode.h
--- a/libpurple/countingnode.h
+++ b/libpurple/countingnode.h
@@ -30,6 +30,7 @@
 #include <glib-object.h>
 
 #include "blistnode.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_COUNTING_NODE             (purple_counting_node_get_type())
 #define PURPLE_COUNTING_NODE(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), PURPLE_TYPE_COUNTING_NODE, PurpleCountingNode))
@@ -82,6 +83,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_counting_node_get_type(void);
 
 /**
@@ -94,6 +96,7 @@ GType purple_counting_node_get_type(void
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_counting_node_get_total_size(PurpleCountingNode *counter);
 
 /**
@@ -107,6 +110,7 @@ int purple_counting_node_get_total_size(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_counting_node_get_current_size(PurpleCountingNode *counter);
 
 /**
@@ -119,6 +123,7 @@ int purple_counting_node_get_current_siz
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_counting_node_get_online_count(PurpleCountingNode *counter);
 
 /**
@@ -132,6 +137,7 @@ int purple_counting_node_get_online_coun
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_counting_node_change_total_size(PurpleCountingNode *counter, int delta);
 
 /**
@@ -145,6 +151,7 @@ void purple_counting_node_change_total_s
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_counting_node_change_current_size(PurpleCountingNode *counter, int delta);
 
 /**
@@ -158,6 +165,7 @@ void purple_counting_node_change_current
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_counting_node_change_online_count(PurpleCountingNode *counter, int delta);
 
 /**
@@ -169,6 +177,7 @@ void purple_counting_node_change_online_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_counting_node_set_total_size(PurpleCountingNode *counter, int totalsize);
 
 /**
@@ -181,6 +190,7 @@ void purple_counting_node_set_total_size
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_counting_node_set_current_size(PurpleCountingNode *counter, int currentsize);
 
 /**
@@ -192,6 +202,7 @@ void purple_counting_node_set_current_si
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_counting_node_set_online_count(PurpleCountingNode *counter, int onlinecount);
 
 G_END_DECLS
diff --git a/libpurple/idle.h b/libpurple/idle.h
--- a/libpurple/idle.h
+++ b/libpurple/idle.h
@@ -30,6 +30,7 @@
 #include <glib-object.h>
 
 #include "purpleidleui.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -67,6 +68,7 @@ void purple_idle_set(time_t time);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_idle_set_ui(PurpleIdleUi *ui);
 
 /**
@@ -79,6 +81,7 @@ void purple_idle_set_ui(PurpleIdleUi *ui
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleIdleUi *purple_idle_get_ui(void);
 
 /**
diff --git a/libpurple/media-gst.h b/libpurple/media-gst.h
--- a/libpurple/media-gst.h
+++ b/libpurple/media-gst.h
@@ -28,6 +28,7 @@
 
 #include "media.h"
 #include "mediamanager.h"
+#include "purpleversion.h"
 
 #include <gst/gst.h>
 
@@ -153,8 +154,8 @@ GstElement *purple_media_manager_get_ele
  *
  * Since: 3.0.0
  */
-GList *purple_media_manager_enumerate_elements(PurpleMediaManager *manager,
-		PurpleMediaElementType type);
+PURPLE_AVAILABLE_IN_3_0
+GList *purple_media_manager_enumerate_elements(PurpleMediaManager *manager, PurpleMediaElementType type);
 
 /**
  * purple_media_manager_get_element_info:
diff --git a/libpurple/network.h b/libpurple/network.h
--- a/libpurple/network.h
+++ b/libpurple/network.h
@@ -29,6 +29,8 @@
 #include <glib.h>
 #include <gio/gio.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 /**************************************************************************/
@@ -69,6 +71,7 @@ const char *purple_network_get_public_ip
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_network_discover_my_ip(void);
 
 /**
diff --git a/libpurple/notify.h b/libpurple/notify.h
--- a/libpurple/notify.h
+++ b/libpurple/notify.h
@@ -30,6 +30,8 @@
 #include <glib-object.h>
 #include <glib.h>
 
+#include "purpleversion.h"
+
 typedef struct _PurpleNotifyUserInfoEntry	PurpleNotifyUserInfoEntry;
 
 #define  PURPLE_TYPE_NOTIFY_USER_INFO  (purple_notify_user_info_get_type())
@@ -343,6 +345,7 @@ PurpleNotifySearchColumn *purple_notify_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_notify_searchresult_column_get_title(const PurpleNotifySearchColumn *column);
 
 /**
@@ -354,6 +357,7 @@ const char *purple_notify_searchresult_c
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notify_searchresult_column_set_visible(PurpleNotifySearchColumn *column, gboolean visible);
 
 /**
@@ -366,6 +370,7 @@ void purple_notify_searchresult_column_s
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_notify_searchresult_column_is_visible(const PurpleNotifySearchColumn *column);
 
 /**
@@ -590,6 +595,7 @@ void purple_notify_user_info_prepend_pai
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notify_user_info_prepend_pair_plaintext(PurpleNotifyUserInfo *user_info, const char *label, const char *value);
 
 /**
@@ -634,6 +640,7 @@ PurpleNotifyUserInfoEntry *purple_notify
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notify_user_info_entry_destroy(PurpleNotifyUserInfoEntry *user_info_entry);
 
 /**
diff --git a/libpurple/protocols.h b/libpurple/protocols.h
--- a/libpurple/protocols.h
+++ b/libpurple/protocols.h
@@ -32,6 +32,7 @@
 
 #include "media.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 #include "status.h"
 
 G_BEGIN_DECLS
@@ -86,6 +87,7 @@ void purple_protocol_got_user_status(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_got_user_status_with_attributes(PurpleAccount *account, const gchar *name, const gchar *status_id, GHashTable *attributes);
 
 /**
diff --git a/libpurple/purpleaccount.h b/libpurple/purpleaccount.h
--- a/libpurple/purpleaccount.h
+++ b/libpurple/purpleaccount.h
@@ -41,6 +41,7 @@ typedef struct _PurpleAccount PurpleAcco
 #include "purplecontactinfo.h"
 #include "purpleprotocol.h"
 #include "purpleproxyinfo.h"
+#include "purpleversion.h"
 #include "status.h"
 
 G_BEGIN_DECLS
@@ -93,6 +94,7 @@ void purple_account_disconnect(PurpleAcc
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_account_is_disconnecting(PurpleAccount *account);
 
 /**
@@ -259,6 +261,7 @@ void purple_account_set_status(PurpleAcc
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_set_status_attrs(PurpleAccount *account, const char *status_id, gboolean active, GHashTable *attrs);
 
 /**
@@ -362,6 +365,7 @@ const char *purple_account_get_protocol_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleProtocol *purple_account_get_protocol(PurpleAccount *account);
 
 /**
@@ -629,6 +633,7 @@ const PurpleConnectionErrorInfo *purple_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_set_error(PurpleAccount *account, PurpleConnectionErrorInfo *info);
 
 /**
@@ -642,6 +647,7 @@ void purple_account_set_error(PurpleAcco
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_set_require_password(PurpleAccount *account, gboolean require_password);
 
 /**
@@ -654,6 +660,7 @@ void purple_account_set_require_password
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_account_get_require_password(PurpleAccount *account);
 
 /**
@@ -674,6 +681,7 @@ gboolean purple_account_get_require_pass
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_freeze_notify_settings(PurpleAccount *account);
 
 /**
@@ -686,6 +694,7 @@ void purple_account_freeze_notify_settin
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_thaw_notify_settings(PurpleAccount *account);
 
 G_END_DECLS
diff --git a/libpurple/purpleaccountmanager.h b/libpurple/purpleaccountmanager.h
--- a/libpurple/purpleaccountmanager.h
+++ b/libpurple/purpleaccountmanager.h
@@ -27,10 +27,13 @@
 #include <glib-object.h>
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_ACCOUNT_MANAGER (purple_account_manager_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleAccountManager, purple_account_manager, PURPLE, ACCOUNT_MANAGER, GObject)
 
 /**
@@ -42,6 +45,7 @@ G_DECLARE_FINAL_TYPE(PurpleAccountManage
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleAccountManagerForeachFunc)(PurpleAccount *account, gpointer data);
 
 /**
@@ -61,6 +65,7 @@ typedef void (*PurpleAccountManagerForea
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccountManager *purple_account_manager_get_default(void);
 
 /**
@@ -72,6 +77,7 @@ PurpleAccountManager *purple_account_man
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GListModel *purple_account_manager_get_default_as_model(void);
 
 /**
@@ -83,6 +89,7 @@ GListModel *purple_account_manager_get_d
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_manager_add(PurpleAccountManager *manager, PurpleAccount *account);
 
 /**
@@ -94,6 +101,7 @@ void purple_account_manager_add(PurpleAc
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_manager_remove(PurpleAccountManager *manager, PurpleAccount *account);
 
 /**
@@ -106,6 +114,7 @@ void purple_account_manager_remove(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_manager_reorder(PurpleAccountManager *manager, PurpleAccount *account, guint new_index);
 
 /**
@@ -119,6 +128,7 @@ void purple_account_manager_reorder(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_account_manager_get_enabled(PurpleAccountManager *manager);
 
 /**
@@ -132,6 +142,7 @@ GList *purple_account_manager_get_enable
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_account_manager_get_disabled(PurpleAccountManager *manager);
 
 /**
@@ -145,6 +156,7 @@ GList *purple_account_manager_get_disabl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_account_manager_get_connected(PurpleAccountManager *manager);
 
 /**
@@ -158,6 +170,7 @@ GList *purple_account_manager_get_connec
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_account_manager_find_by_id(PurpleAccountManager *manager, const gchar *id);
 
 /**
@@ -173,6 +186,7 @@ PurpleAccount *purple_account_manager_fi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_account_manager_find(PurpleAccountManager *manager, const gchar *username, const gchar *protocol_id);
 
 /**
@@ -188,6 +202,7 @@ PurpleAccount *purple_account_manager_fi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount * purple_account_manager_find_custom(PurpleAccountManager *manager, GEqualFunc func, gconstpointer data);
 
 /**
@@ -200,6 +215,7 @@ PurpleAccount * purple_account_manager_f
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_account_manager_foreach(PurpleAccountManager *manager, PurpleAccountManagerForeachFunc callback, gpointer data);
 
 G_END_DECLS
diff --git a/libpurple/purpleaccountoption.h b/libpurple/purpleaccountoption.h
--- a/libpurple/purpleaccountoption.h
+++ b/libpurple/purpleaccountoption.h
@@ -30,6 +30,7 @@
 #include <glib-object.h>
 
 #include "prefs.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_ACCOUNT_OPTION (purple_account_option_get_type())
 
@@ -72,6 +73,7 @@ PurpleAccountOption *purple_account_opti
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccountOption *purple_account_option_copy(PurpleAccountOption *option);
 
 /**
diff --git a/libpurple/purpleaccountpresence.h b/libpurple/purpleaccountpresence.h
--- a/libpurple/purpleaccountpresence.h
+++ b/libpurple/purpleaccountpresence.h
@@ -28,6 +28,7 @@
 
 #include "purpleaccount.h"
 #include "purplepresence.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -52,6 +53,7 @@ G_DECLARE_FINAL_TYPE(PurpleAccountPresen
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccountPresence *purple_account_presence_new(PurpleAccount *account);
 
 /**
diff --git a/libpurple/purpleaccountusersplit.h b/libpurple/purpleaccountusersplit.h
--- a/libpurple/purpleaccountusersplit.h
+++ b/libpurple/purpleaccountusersplit.h
@@ -29,6 +29,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_ACCOUNT_USER_SPLIT (purple_account_user_split_get_type())
 
 /**
@@ -67,6 +69,7 @@ PurpleAccountUserSplit *purple_account_u
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccountUserSplit *purple_account_user_split_copy(PurpleAccountUserSplit *split);
 
 /**
diff --git a/libpurple/purpleaddcontactrequest.h b/libpurple/purpleaddcontactrequest.h
--- a/libpurple/purpleaddcontactrequest.h
+++ b/libpurple/purpleaddcontactrequest.h
@@ -27,6 +27,7 @@
 #include <glib-object.h>
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -41,6 +42,8 @@ G_BEGIN_DECLS
  */
 
 #define PURPLE_TYPE_ADD_CONTACT_REQUEST (purple_add_contact_request_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleAddContactRequest, purple_add_contact_request,
                      PURPLE, ADD_CONTACT_REQUEST, GObject)
 
@@ -57,6 +60,7 @@ G_DECLARE_FINAL_TYPE(PurpleAddContactReq
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAddContactRequest *purple_add_contact_request_new(PurpleAccount *account, const gchar *username);
 
 /**
@@ -69,6 +73,7 @@ PurpleAddContactRequest *purple_add_cont
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_add_contact_request_get_account(PurpleAddContactRequest *request);
 
 /**
@@ -81,6 +86,7 @@ PurpleAccount *purple_add_contact_reques
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_add_contact_request_get_username(PurpleAddContactRequest *request);
 
 /**
@@ -93,6 +99,7 @@ const gchar *purple_add_contact_request_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_add_contact_request_set_alias(PurpleAddContactRequest *request, const gchar *alias);
 
 /**
@@ -105,6 +112,7 @@ void purple_add_contact_request_set_alia
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_add_contact_request_get_alias(PurpleAddContactRequest *request);
 
 /**
@@ -117,6 +125,7 @@ const gchar *purple_add_contact_request_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_add_contact_request_set_message(PurpleAddContactRequest *request, const gchar *message);
 
 /**
@@ -129,6 +138,7 @@ void purple_add_contact_request_set_mess
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_add_contact_request_get_message(PurpleAddContactRequest *request);
 
 /**
@@ -142,6 +152,7 @@ const gchar *purple_add_contact_request_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_add_contact_request_add(PurpleAddContactRequest *request);
 
 G_END_DECLS
diff --git a/libpurple/purpleattachment.h b/libpurple/purpleattachment.h
--- a/libpurple/purpleattachment.h
+++ b/libpurple/purpleattachment.h
@@ -28,6 +28,8 @@
 
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_ATTACHMENT purple_attachment_get_type()
@@ -60,6 +62,7 @@ typedef void (*PurpleAttachmentForeachFu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAttachment *purple_attachment_new(guint64 id, const gchar *content_type);
 
 /**
@@ -72,6 +75,7 @@ PurpleAttachment *purple_attachment_new(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint64 purple_attachment_get_id(PurpleAttachment *attachment);
 
 /**
@@ -86,6 +90,7 @@ guint64 purple_attachment_get_id(PurpleA
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint64 *purple_attachment_get_hash_key(PurpleAttachment *attachment);
 
 /**
@@ -97,6 +102,7 @@ guint64 *purple_attachment_get_hash_key(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_attachment_set_id(PurpleAttachment *attachment, guint64 id);
 
 /**
@@ -109,6 +115,7 @@ void purple_attachment_set_id(PurpleAtta
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_attachment_get_content_type(PurpleAttachment *attachment);
 
 /**
@@ -121,6 +128,7 @@ const gchar *purple_attachment_get_conte
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_attachment_get_local_uri(PurpleAttachment *attachment);
 
 /**
@@ -132,6 +140,7 @@ const gchar *purple_attachment_get_local
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_attachment_set_local_uri(PurpleAttachment *attachment, const gchar *local_uri);
 
 /**
@@ -144,6 +153,7 @@ void purple_attachment_set_local_uri(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_attachment_get_remote_uri(PurpleAttachment *attachment);
 
 /**
@@ -155,6 +165,7 @@ const gchar *purple_attachment_get_remot
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_attachment_set_remote_uri(PurpleAttachment *attachment, const gchar *remote_uri);
 
 /**
@@ -167,6 +178,7 @@ void purple_attachment_set_remote_uri(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint64 purple_attachment_get_size(PurpleAttachment *attachment);
 
 /**
@@ -178,6 +190,7 @@ guint64 purple_attachment_get_size(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_attachment_set_size(PurpleAttachment *attachment, guint64 size);
 
 /**
@@ -191,6 +204,7 @@ void purple_attachment_set_size(PurpleAt
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gchar *purple_attachment_get_filename(PurpleAttachment *attachment);
 
 G_END_DECLS
diff --git a/libpurple/purpleauthorizationrequest.h b/libpurple/purpleauthorizationrequest.h
--- a/libpurple/purpleauthorizationrequest.h
+++ b/libpurple/purpleauthorizationrequest.h
@@ -27,6 +27,7 @@
 #include <glib-object.h>
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -42,6 +43,7 @@ G_BEGIN_DECLS
 
 #define PURPLE_TYPE_AUTHORIZATION_REQUEST (purple_authorization_request_get_type())
 
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleAuthorizationRequest, purple_authorization_request,
                      PURPLE, AUTHORIZATION_REQUEST, GObject)
 
@@ -58,6 +60,7 @@ G_DECLARE_FINAL_TYPE(PurpleAuthorization
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAuthorizationRequest *purple_authorization_request_new(PurpleAccount *account, const gchar *username);
 
 /**
@@ -70,6 +73,7 @@ PurpleAuthorizationRequest *purple_autho
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_authorization_request_get_account(PurpleAuthorizationRequest *request);
 
 /**
@@ -82,6 +86,7 @@ PurpleAccount *purple_authorization_requ
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_authorization_request_get_username(PurpleAuthorizationRequest *request);
 
 /**
@@ -94,6 +99,7 @@ const gchar *purple_authorization_reques
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_authorization_request_set_alias(PurpleAuthorizationRequest *request, const gchar *alias);
 
 /**
@@ -106,6 +112,7 @@ void purple_authorization_request_set_al
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_authorization_request_get_alias(PurpleAuthorizationRequest *request);
 
 /**
@@ -118,6 +125,7 @@ const gchar *purple_authorization_reques
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_authorization_request_set_message(PurpleAuthorizationRequest *request, const gchar *message);
 
 /**
@@ -130,6 +138,7 @@ void purple_authorization_request_set_me
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_authorization_request_get_message(PurpleAuthorizationRequest *request);
 
 /**
@@ -142,6 +151,7 @@ const gchar *purple_authorization_reques
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_authorization_request_set_add(PurpleAuthorizationRequest *request, gboolean add);
 
 /**
@@ -156,6 +166,7 @@ void purple_authorization_request_set_ad
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_authorization_request_get_add(PurpleAuthorizationRequest *request);
 
 /**
@@ -170,6 +181,7 @@ gboolean purple_authorization_request_ge
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_authorization_request_accept(PurpleAuthorizationRequest *request);
 
 /**
@@ -185,6 +197,7 @@ void purple_authorization_request_accept
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_authorization_request_deny(PurpleAuthorizationRequest *request, const gchar *message);
 
 G_END_DECLS
diff --git a/libpurple/purpleavatar.h b/libpurple/purpleavatar.h
--- a/libpurple/purpleavatar.h
+++ b/libpurple/purpleavatar.h
@@ -29,10 +29,13 @@
 #include <gdk-pixbuf/gdk-pixbuf.h>
 
 #include "purpletags.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_AVATAR (purple_avatar_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleAvatar, purple_avatar, PURPLE, AVATAR, GObject)
 
 /**
@@ -55,6 +58,7 @@ G_DECLARE_FINAL_TYPE(PurpleAvatar, purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAvatar *purple_avatar_new_from_filename(const char *filename, GError **error);
 
 /**
@@ -68,6 +72,7 @@ PurpleAvatar *purple_avatar_new_from_fil
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAvatar *purple_avatar_new_from_resource(const char *resource_path, GError **error);
 
 /**
@@ -80,6 +85,7 @@ PurpleAvatar *purple_avatar_new_from_res
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_avatar_get_filename(PurpleAvatar *avatar);
 
 /**
@@ -96,6 +102,7 @@ const char *purple_avatar_get_filename(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GdkPixbuf *purple_avatar_get_pixbuf(PurpleAvatar *avatar);
 
 /**
@@ -108,6 +115,7 @@ GdkPixbuf *purple_avatar_get_pixbuf(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_avatar_get_animated(PurpleAvatar *avatar);
 
 /**
@@ -121,6 +129,7 @@ gboolean purple_avatar_get_animated(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GdkPixbufAnimation *purple_avatar_get_animation(PurpleAvatar *avatar);
 
 /**
@@ -133,6 +142,7 @@ GdkPixbufAnimation *purple_avatar_get_an
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleTags *purple_avatar_get_tags(PurpleAvatar *avatar);
 
 G_END_DECLS
diff --git a/libpurple/purplebuddypresence.h b/libpurple/purplebuddypresence.h
--- a/libpurple/purplebuddypresence.h
+++ b/libpurple/purplebuddypresence.h
@@ -28,6 +28,7 @@
 
 #include "buddylist.h"
 #include "purplepresence.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -52,6 +53,7 @@ G_DECLARE_FINAL_TYPE(PurpleBuddyPresence
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBuddyPresence *purple_buddy_presence_new(PurpleBuddy *buddy);
 
 /**
